=== modified file 'crypt.py'
--- crypt.py	2008-04-01 18:58:12 +0000
+++ crypt.py	2008-04-01 19:20:08 +0000
@@ -49,8 +49,6 @@
         self.flags = None
         self.display_name = None
 
-        discover(key)
-
     def get_field(self, field, default=None):
         (valid, value) = openpgp.GetKeyField(self.key, field)
 
@@ -86,8 +84,8 @@
 
         return self.trust
 
-    def is_valid(self):
-        return self.get_flags() & FLAG_VALID
+    def is_available(self):
+        return self.key != ""
 
     def is_trusted(self):
         return self.get_flags() & FLAG_TRUSTED

=== modified file 'revisionview.py'
--- revisionview.py	2008-04-01 18:28:51 +0000
+++ revisionview.py	2008-04-01 19:20:08 +0000
@@ -133,6 +133,24 @@
     def show_signature(self, crypttext):
         key = crypt.verify(crypttext)
 
+        if not key.is_available():
+            self.show_no_signature()
+            self.signature_image.set_from_file(icon_path("sign-bad.png"))
+            self.signature_label.set_markup("<b>Authentication error</b>\n" +
+                                            "Signature key not available")
+            return
+
+        if key.is_trusted():
+            self.signature_image.set_from_file(icon_path("sign-ok.png"))
+            self.signature_label.set_markup("<b>Authenticity confirmed</b>\n" +
+                                            "This revision has been signed by " +
+                                            "a trusted party.")
+        else:
+            self.signature_image.set_from_file(icon_path("sign-bad.png"))
+            self.signature_label.set_markup("<b>Authenticity cannot be confirmed</b>\n" +
+                                            "This revision has been signed by " +
+                                            "an untrusted party.")
+
         trust = key.get_trust()
 
         if trust <= crypt.TRUST_NEVER:
@@ -154,18 +172,7 @@
 
         self.signature_trust_label.show()
         self.signature_trust.set_text('This key is ' + trust_text)
-
-        if key.is_trusted():
-            self.signature_image.set_from_file(icon_path("sign-ok.png"))
-            self.signature_label.set_markup("<b>Authenticity confirmed</b>\n" +
-                                            "This revision has been signed by " +
-                                            "a trusted party.")
-        else:
-            self.signature_image.set_from_file(icon_path("sign-bad.png"))
-            self.signature_label.set_markup("<b>Authenticity cannot be confirmed</b>\n" +
-                                            "This revision has been signed by " +
-                                            "an untrusted party.")
-
+        
 
 class RevisionView(gtk.Notebook):
     """ Custom widget for commit log details.

